// Unique.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
using namespace std;

/* Ӧ̳
 * STL и vector ȥصַ: https://xmuli.blog.csdn.net/article/details/126322011
 * STL  std::set ԶṹĶ󣬶ϸıȽϺ: https://xmuli.blog.csdn.net/article/details/126354597
*/ 

struct MyData
{
    wstring name;
    wstring md5;

    // ʽһ < 
    //bool operator<(const MyData& d) const noexcept {
    //    return md5 < d.md5;
    //}
};

// ʽԶṹͣԶȽϺ _Pr βõķʽ
bool cmpSort(const MyData& d1, const MyData& d2) {
    // Simple example
    return d1.md5 < d2.md5;

    // Complex sample
    //if (d1.md5 != d2.md5)
    //    return d1.md5 < d2.md5;
    //else
    //    return d1.name < d2.name;
};

// ʽ֣ͬ Lambda ʽĳЩ㷨лʧЧ
auto cmpSortLambda = [](const MyData& d1, const MyData& d2) {
    return d1.md5 < d2.md5;
};

// ʽԡ£дԵģ˴ջ
struct cmpSortObj
{
    bool operator()(const MyData& d1, const MyData& d2) const {
        return d1.md5 < d2.md5;
    }
};

// ************* std::unique ԶȽϺ *************
bool cmpUnique(const MyData& d1, const MyData& d2) {
    return d1.md5 == d2.md5;                             // ϸȣԴﵽĿ꣬ڴй©
    //return d1.md5 == d2.md5 && d1.name == d2.name;     // ﷨ͱ룬ʵ
};

int main()
{
    vector<MyData> vec = { { L"a1.exe", L"B9204B6362A65C248950D5A41F341DCC"},
                           { L"a2.exe", L"B9204B6362A65C248950D5A41F341DCC"},
                           { L"b1.exe", L"C96D1AA5D314954417C28A645ED72665"},
                           { L"b2.exe", L"C96D1AA5D314954417C28A645ED72665"} };

    wcout.imbue(locale("", LC_CTYPE));
    wcout << L"----------ǰ--------" << endl;
    for (const auto& it : vec)
        wcout << L"[it.name]" << it.name << L"[it.md5]" << it.md5 << endl;

    // ************* һvector, sort + unique *************
    //sort(vec.begin(), vec.end(), cmpSort);
    //auto ite = std::unique(vec.begin(), vec.end(), cmpUnique);
    //vec.erase(ite, vec.end());

    // ************* vector + setֵֶ *************
    //set<MyData, cmpSortObj>  s;                           // "" set  --> OK
    set<MyData, decltype(cmpSort)*>  s(&cmpSort);           // "ͨ + decltype" set  -->    OK:  롢гɹҲɹ
    //set<MyData, decltype(cmpSort)*>  s;                   //                                      --> Error:  롢гɹԻʧ

    for (unsigned i = 0; i < vec.size(); ++i)
        s.insert(vec[i]);                                   // ʱп֤洴 std::set Ľ
    vec.assign(s.begin(), s.end());

    // ************* vector + set캯 *************
    // Чʲ硺

    wcout << L"------------------" << endl;
    for (const auto& it : vec)
        wcout << L"[it.name]" << it.name << L"[it.md5]" << it.md5 << endl;

    return 0;
}